/* Checkbook
 *
 * Version 1.1
 * 9/24/2020
 *
 * Checkbook functions
 *
 * checkbook.c
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "checkbook.h"

int exist(char file[])
{
	FILE *fptr;
	fptr = fopen(file, "r");
	if (!fptr)
	{
		return 0;
	} else {
		fclose(fptr);
		return 1;
	}
}

int readfile(void)
{
	if (!exist(cfile()))
	{
		printf(CFILE_MISSING, cfile());
		return 1;
	}
	FILE *fptr;
	char buffer[512];
	char tfile[128];
	strcpy(tfile, cfile());
	int line = -8;

	fptr = fopen(tfile,"r");

	if (!fptr)
	{
		return 1;
	}

        while(1)
	{
		line++;
		fgets(buffer, 512, fptr);
		if (feof(fptr)) {
			break;
		}

		if (line > 0)
		{
			printf("%d:\t%s", line, buffer);
		} else {
			printf("\t%s", buffer);
		}
	}

	fclose(fptr);
	return 0;
}

int appendfile(char string[])
{
	if (!exist(cfile()))
		{
		printf(CFILE_MISSING, cfile());
		return 1;
	}
	FILE *fptr;
	char fname[128];
	char txt[128];

	strcpy(fname, cfile());
	strcpy(txt, string);

	fptr = fopen(fname, "a");

	if (!fptr)
	{
		return 1;
	}
	fprintf(fptr, "%s", txt);
	fclose(fptr);
	return 0;
}

int insertline(int ln, char string[])
{
        if (!exist(cfile()))
        {
                printf(CFILE_MISSING, cfile());
                return 1;
        }
	FILE *fptr;
	FILE *xptr;
	char tmpfile[128];
	char buffer[512];
	char tfile[128];
	strcpy(tfile, cfile());
	int line = 0;

	sprintf(tmpfile, "%s/._%s.tmp", HOME, CFILE);

	fptr = fopen(tfile, "r");
	xptr = fopen(tmpfile, "w");

	if (!fptr)
	{
		fclose(xptr);
		return 1;
	}

	while(1)
	{
		line++;
		fgets(buffer, 512, fptr);

		if (feof(fptr))
		{
			break;
		}
		if (line != ln)
		{
			fprintf(xptr, "%s", buffer);
		} else if (line == ln)
		{
			fprintf(xptr, "%s", string);
			fprintf(xptr, "%s", buffer);
		}
	}

	fclose(fptr);
	fclose(xptr);

	remove(tfile);
	rename(tmpfile, tfile);

	return 0;
}


int rmline(int ln)
{
	if (!exist(cfile()))
	{
		printf(CFILE_MISSING, cfile());
		return 1;
	}
	FILE *fptr;
	FILE *xptr;
	char tmpfile[128];
	char buffer[512];
	char tfile[128];
	strcpy(tfile, cfile());
	int line = 0;

	sprintf(tmpfile, "%s/._%s.tmp", HOME, CFILE);

	fptr = fopen(tfile, "r");
	xptr = fopen(tmpfile, "w");

	if (!fptr)
	{
		fclose(xptr);
		return 1;
	}

	rewind(fptr);

	while(1)
	{
		line++;
		fgets(buffer, 512, fptr);

		if (feof(fptr))
		{
			break;
		}
		if (line != ln)
		{
			fprintf(xptr, "%s", buffer);
		}
	}	

	fclose(fptr);
	fclose(xptr);

	remove(tfile);
	rename(tmpfile, tfile);

	return 0;
}

char * cfile(void)
{
	static char _cfile[52];
	sprintf(_cfile, "%s/%s", HOME, CFILE);
	return _cfile;
}

void new_file(void)
{
	if (exist(cfile()))
	{
		char yn[2];
		printf("Checkbook file %s already exists\nDo you want to overwrite it? (y/n) ", cfile());
		scanf("%s", yn);
		if (!strcmp(yn, "y") || !strcmp(yn, "Y"))
		{
			remove(cfile());
			printf("Deleted %s\n", cfile());
		} else {
			printf("%s will not be overwritten.\n", cfile());
			return;
		}
	}
	static double st_bal;
	printf("Starting balance for %s: $", cfile());
	scanf("%lf", &st_bal);
	FILE *fptr;
	fptr = fopen(cfile(), "w");
	fprintf(fptr, HEADER, USER, st_bal);
	fclose(fptr);
	printf("Checkbook file %s created\n", cfile());
	return;
}

double get_balance(void)
{
	if (!exist(cfile()))
	{
		printf(CFILE_MISSING, cfile());
		return 0.0;
	}
	int x;
	static double b;
	static char _b[24];
	char *_junk;
	FILE *fptr;
	fptr = fopen(cfile(), "r");
	rewind(fptr);
	fseek(fptr, (strlen(MAIN_HEADER) - 2) + strlen(USER), SEEK_SET);
	fgets(_b, 24, fptr);
	fclose(fptr);
	b = strtod(_b, &_junk);
	return b;
}

double dec_balance(double amount)
{
	if (!exist(cfile()))
	{
		printf(CFILE_MISSING, cfile());
		return 0.0;
	}
	double cbal = get_balance();
	nbal = cbal - amount;
	char _nbal[64];
	sprintf(_nbal, "$%.2lf\n", nbal);
	rmline(4);
	insertline(4, _nbal);
	return nbal;
}

double inc_balance(double amount)
{
	if (!exist(cfile()))
	{
		printf(CFILE_MISSING, cfile());
		return 0.0;
	}
	double cbal = get_balance();
	inbal = cbal + amount;
	char _inbal[64];
	sprintf(_inbal, "$%.2lf\n", inbal);
	rmline(4);
	insertline(4, _inbal);
	return inbal;
}

void withdraw(char num[8], char date[10], char desc[16], double amount)
{
	if (!exist(cfile()))
	{
		printf(CFILE_MISSING, cfile());
		return;
	}
	char ent_str[56];
	char amt_str[12];
	dec_balance(amount);
	sprintf(amt_str, " $%.2f", amount);
	sprintf(ent_str, "%s\t%s\t%s%s-$%.2f%s$%.2f\n", num, date, desc, tab(strlen(desc)), amount, ttab(strlen(amt_str)), get_balance());
	appendfile(ent_str);
	printf("Transaction complete.\n");
	return;
}

void deposit(char num[8], char date[10], char desc[16], double amount)
{
	if (!exist(cfile()))
	{
		printf(CFILE_MISSING, cfile());
		return;
	}
	char ent_str[56];
	char amt_str[12];
	inc_balance(amount);
	sprintf(amt_str, " $%.2f", amount);
	sprintf(ent_str, "%s\t%s\t%s%s+$%.2f%s$%.2f\n", num, date, desc, tab(strlen(desc)), amount, ttab(strlen(amt_str)), get_balance());
	appendfile(ent_str);
	printf("Transaction complete.\n");
	return;
}

char * tab(int len)
{
	static char tab_ret[8];
	if (len <= 6)
	{
		strcpy(tab_ret, "\t\t\t\t");
	} else if (len > 6) {
		strcpy(tab_ret, "\t\t\t");
	} else if (len > 12) {
		strcpy(tab_ret, "\t");
	} else {
		strcpy(tab_ret, "");
	} 
	return tab_ret;
}

char * ttab(int len)
{
	static char tab_ret[8];
	if (len <= 7)
	{
		strcpy(tab_ret, "\t\t\t");
	} else if (len > 7) {
		strcpy(tab_ret, "\t\t");
	} else if (len > 13) {
		strcpy(tab_ret, "");
	}
	return tab_ret;
}
